/**
 * @name array-of-arrays-into-ast
 * @fileoverview Turns an array of arrays of data into a nested tree of plain objects
 * @version 4.0.19
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/array-of-arrays-into-ast/}
 */

"use strict";var arrayOfArraysIntoAst=(()=>{var at=Object.create;var M=Object.defineProperty,ot=Object.defineProperties,ft=Object.getOwnPropertyDescriptor,nt=Object.getOwnPropertyDescriptors,st=Object.getOwnPropertyNames,Y=Object.getOwnPropertySymbols,it=Object.getPrototypeOf,te=Object.prototype.hasOwnProperty,pt=Object.prototype.propertyIsEnumerable;var ee=(e,t,a)=>t in e?M(e,t,{enumerable:!0,configurable:!0,writable:!0,value:a}):e[t]=a,h=(e,t)=>{for(var a in t||(t={}))te.call(t,a)&&ee(e,a,t[a]);if(Y)for(var a of Y(t))pt.call(t,a)&&ee(e,a,t[a]);return e},F=(e,t)=>ot(e,nt(t));var ut=(e,t)=>()=>(t||e((t={exports:{}}).exports,t),t.exports),lt=(e,t)=>{for(var a in t)M(e,a,{get:t[a],enumerable:!0})},re=(e,t,a,r)=>{if(t&&typeof t=="object"||typeof t=="function")for(let n of st(t))!te.call(e,n)&&n!==a&&M(e,n,{get:()=>t[n],enumerable:!(r=ft(t,n))||r.enumerable});return e};var ae=(e,t,a)=>(a=e!=null?at(it(e)):{},re(t||!e||!e.__esModule?M(a,"default",{value:e,enumerable:!0}):a,e)),mt=e=>re(M({},"__esModule",{value:!0}),e);var J=ut((Df,ze)=>{"use strict";ze.exports=ma;function I(e){return e instanceof Buffer?Buffer.from(e):new e.constructor(e.buffer.slice(),e.byteOffset,e.length)}function ma(e){if(e=e||{},e.circles)return da(e);return e.proto?r:a;function t(n,f){for(var o=Object.keys(n),s=new Array(o.length),u=0;u<o.length;u++){var l=o[u],c=n[l];typeof c!="object"||c===null?s[l]=c:c instanceof Date?s[l]=new Date(c):ArrayBuffer.isView(c)?s[l]=I(c):s[l]=f(c)}return s}function a(n){if(typeof n!="object"||n===null)return n;if(n instanceof Date)return new Date(n);if(Array.isArray(n))return t(n,a);if(n instanceof Map)return new Map(t(Array.from(n),a));if(n instanceof Set)return new Set(t(Array.from(n),a));var f={};for(var o in n)if(Object.hasOwnProperty.call(n,o)!==!1){var s=n[o];typeof s!="object"||s===null?f[o]=s:s instanceof Date?f[o]=new Date(s):s instanceof Map?f[o]=new Map(t(Array.from(s),a)):s instanceof Set?f[o]=new Set(t(Array.from(s),a)):ArrayBuffer.isView(s)?f[o]=I(s):f[o]=a(s)}return f}function r(n){if(typeof n!="object"||n===null)return n;if(n instanceof Date)return new Date(n);if(Array.isArray(n))return t(n,r);if(n instanceof Map)return new Map(t(Array.from(n),r));if(n instanceof Set)return new Set(t(Array.from(n),r));var f={};for(var o in n){var s=n[o];typeof s!="object"||s===null?f[o]=s:s instanceof Date?f[o]=new Date(s):s instanceof Map?f[o]=new Map(t(Array.from(s),r)):s instanceof Set?f[o]=new Set(t(Array.from(s),r)):ArrayBuffer.isView(s)?f[o]=I(s):f[o]=r(s)}return f}}function da(e){var t=[],a=[];return e.proto?f:n;function r(o,s){for(var u=Object.keys(o),l=new Array(u.length),c=0;c<u.length;c++){var m=u[c],i=o[m];if(typeof i!="object"||i===null)l[m]=i;else if(i instanceof Date)l[m]=new Date(i);else if(ArrayBuffer.isView(i))l[m]=I(i);else{var x=t.indexOf(i);x!==-1?l[m]=a[x]:l[m]=s(i)}}return l}function n(o){if(typeof o!="object"||o===null)return o;if(o instanceof Date)return new Date(o);if(Array.isArray(o))return r(o,n);if(o instanceof Map)return new Map(r(Array.from(o),n));if(o instanceof Set)return new Set(r(Array.from(o),n));var s={};t.push(o),a.push(s);for(var u in o)if(Object.hasOwnProperty.call(o,u)!==!1){var l=o[u];if(typeof l!="object"||l===null)s[u]=l;else if(l instanceof Date)s[u]=new Date(l);else if(l instanceof Map)s[u]=new Map(r(Array.from(l),n));else if(l instanceof Set)s[u]=new Set(r(Array.from(l),n));else if(ArrayBuffer.isView(l))s[u]=I(l);else{var c=t.indexOf(l);c!==-1?s[u]=a[c]:s[u]=n(l)}}return t.pop(),a.pop(),s}function f(o){if(typeof o!="object"||o===null)return o;if(o instanceof Date)return new Date(o);if(Array.isArray(o))return r(o,f);if(o instanceof Map)return new Map(r(Array.from(o),f));if(o instanceof Set)return new Set(r(Array.from(o),f));var s={};t.push(o),a.push(s);for(var u in o){var l=o[u];if(typeof l!="object"||l===null)s[u]=l;else if(l instanceof Date)s[u]=new Date(l);else if(l instanceof Map)s[u]=new Map(r(Array.from(l),f));else if(l instanceof Set)s[u]=new Set(r(Array.from(l),f));else if(ArrayBuffer.isView(l))s[u]=I(l);else{var c=t.indexOf(l);c!==-1?s[u]=a[c]:s[u]=f(l)}}return t.pop(),a.pop(),s}}});var Oa={};lt(Oa,{defaults:()=>rt,generateAst:()=>va,version:()=>Aa});var dt=typeof global=="object"&&global&&global.Object===Object&&global,N=dt;var ct=typeof self=="object"&&self&&self.Object===Object&&self,yt=N||ct||Function("return this")(),S=yt;var xt=S.Symbol,T=xt;var oe=Object.prototype,bt=oe.hasOwnProperty,gt=oe.toString,B=T?T.toStringTag:void 0;function ht(e){var t=bt.call(e,B),a=e[B];try{e[B]=void 0;var r=!0}catch(f){}var n=gt.call(e);return r&&(t?e[B]=a:delete e[B]),n}var fe=ht;var At=Object.prototype,jt=At.toString;function vt(e){return jt.call(e)}var ne=vt;var Ot="[object Null]",wt="[object Undefined]",se=T?T.toStringTag:void 0;function St(e){return e==null?e===void 0?wt:Ot:se&&se in Object(e)?fe(e):ne(e)}var A=St;function Tt(e){return e!=null&&typeof e=="object"}var j=Tt;var kt="[object Symbol]";function Et(e){return typeof e=="symbol"||j(e)&&A(e)==kt}var ie=Et;function It(e,t){for(var a=-1,r=e==null?0:e.length,n=Array(r);++a<r;)n[a]=t(e[a],a,e);return n}var pe=It;var Mt=Array.isArray,R=Mt;var Bt=/\s/;function Dt(e){for(var t=e.length;t--&&Bt.test(e.charAt(t)););return t}var ue=Dt;var $t=/^\s+/;function Ct(e){return e&&e.slice(0,ue(e)+1).replace($t,"")}var le=Ct;function Pt(e){var t=typeof e;return e!=null&&(t=="object"||t=="function")}var D=Pt;var me=NaN,Ft=/^[-+]0x[0-9a-f]+$/i,Nt=/^0b[01]+$/i,Rt=/^0o[0-7]+$/i,Lt=parseInt;function Wt(e){if(typeof e=="number")return e;if(ie(e))return me;if(D(e)){var t=typeof e.valueOf=="function"?e.valueOf():e;e=D(t)?t+"":t}if(typeof e!="string")return e===0?e:+e;e=le(e);var a=Nt.test(e);return a||Rt.test(e)?Lt(e.slice(2),a?2:8):Ft.test(e)?me:+e}var de=Wt;var ce=1/0,Kt=17976931348623157e292;function Vt(e){if(!e)return e===0?e:0;if(e=de(e),e===ce||e===-ce){var t=e<0?-1:1;return t*Kt}return e===e?e:0}var ye=Vt;function Ut(e){var t=ye(e),a=t%1;return t===t?a?t-a:t:0}var xe=Ut;var Gt="[object AsyncFunction]",qt="[object Function]",zt="[object GeneratorFunction]",_t="[object Proxy]";function Jt(e){if(!D(e))return!1;var t=A(e);return t==qt||t==zt||t==Gt||t==_t}var be=Jt;function Qt(e,t,a,r){for(var n=e.length,f=a+(r?1:-1);r?f--:++f<n;)if(t(e[f],f,e))return f;return-1}var ge=Qt;function Ht(e){return e!==e}var he=Ht;function Xt(e,t,a){for(var r=a-1,n=e.length;++r<n;)if(e[r]===t)return r;return-1}var Ae=Xt;function Zt(e,t,a){return t===t?Ae(e,t,a):ge(e,he,a)}var je=Zt;var Yt=9007199254740991,er=/^(?:0|[1-9]\d*)$/;function tr(e,t){var a=typeof e;return t=t==null?Yt:t,!!t&&(a=="number"||a!="symbol"&&er.test(e))&&e>-1&&e%1==0&&e<t}var ve=tr;var rr=9007199254740991;function ar(e){return typeof e=="number"&&e>-1&&e%1==0&&e<=rr}var L=ar;function or(e){return e!=null&&L(e.length)&&!be(e)}var W=or;var fr=Object.prototype;function nr(e){var t=e&&e.constructor,a=typeof t=="function"&&t.prototype||fr;return e===a}var Oe=nr;function sr(e,t){for(var a=-1,r=Array(e);++a<e;)r[a]=t(a);return r}var we=sr;var ir="[object Arguments]";function pr(e){return j(e)&&A(e)==ir}var q=pr;var Se=Object.prototype,ur=Se.hasOwnProperty,lr=Se.propertyIsEnumerable,mr=q(function(){return arguments}())?q:function(e){return j(e)&&ur.call(e,"callee")&&!lr.call(e,"callee")},Te=mr;function dr(){return!1}var ke=dr;var Me=typeof exports=="object"&&exports&&!exports.nodeType&&exports,Ee=Me&&typeof module=="object"&&module&&!module.nodeType&&module,cr=Ee&&Ee.exports===Me,Ie=cr?S.Buffer:void 0,yr=Ie?Ie.isBuffer:void 0,xr=yr||ke,Be=xr;var br="[object Arguments]",gr="[object Array]",hr="[object Boolean]",Ar="[object Date]",jr="[object Error]",vr="[object Function]",Or="[object Map]",wr="[object Number]",Sr="[object Object]",Tr="[object RegExp]",kr="[object Set]",Er="[object String]",Ir="[object WeakMap]",Mr="[object ArrayBuffer]",Br="[object DataView]",Dr="[object Float32Array]",$r="[object Float64Array]",Cr="[object Int8Array]",Pr="[object Int16Array]",Fr="[object Int32Array]",Nr="[object Uint8Array]",Rr="[object Uint8ClampedArray]",Lr="[object Uint16Array]",Wr="[object Uint32Array]",y={};y[Dr]=y[$r]=y[Cr]=y[Pr]=y[Fr]=y[Nr]=y[Rr]=y[Lr]=y[Wr]=!0;y[br]=y[gr]=y[Mr]=y[hr]=y[Br]=y[Ar]=y[jr]=y[vr]=y[Or]=y[wr]=y[Sr]=y[Tr]=y[kr]=y[Er]=y[Ir]=!1;function Kr(e){return j(e)&&L(e.length)&&!!y[A(e)]}var De=Kr;function Vr(e){return function(t){return e(t)}}var K=Vr;var $e=typeof exports=="object"&&exports&&!exports.nodeType&&exports,$=$e&&typeof module=="object"&&module&&!module.nodeType&&module,Ur=$&&$.exports===$e,z=Ur&&N.process,Gr=function(){try{var e=$&&$.require&&$.require("util").types;return e||z&&z.binding&&z.binding("util")}catch(t){}}(),k=Gr;var Ce=k&&k.isTypedArray,qr=Ce?K(Ce):De,Pe=qr;var zr=Object.prototype,_r=zr.hasOwnProperty;function Jr(e,t){var a=R(e),r=!a&&Te(e),n=!a&&!r&&Be(e),f=!a&&!r&&!n&&Pe(e),o=a||r||n||f,s=o?we(e.length,String):[],u=s.length;for(var l in e)(t||_r.call(e,l))&&!(o&&(l=="length"||n&&(l=="offset"||l=="parent")||f&&(l=="buffer"||l=="byteLength"||l=="byteOffset")||ve(l,u)))&&s.push(l);return s}var Fe=Jr;function Qr(e,t){return function(a){return e(t(a))}}var Ne=Qr;var Hr=Ne(Object.keys,Object),Re=Hr;var Xr=Object.prototype,Zr=Xr.hasOwnProperty;function Yr(e){if(!Oe(e))return Re(e);var t=[];for(var a in Object(e))Zr.call(e,a)&&a!="constructor"&&t.push(a);return t}var Le=Yr;function ea(e){return W(e)?Fe(e):Le(e)}var We=ea;var ta="[object String]";function ra(e){return typeof e=="string"||!R(e)&&j(e)&&A(e)==ta}var Ke=ra;function aa(e,t){return pe(t,function(a){return e[a]})}var Ve=aa;function oa(e){return e==null?[]:Ve(e,We(e))}var Ue=oa;var fa=Math.max;function na(e,t,a,r){e=W(e)?e:Ue(e),a=a&&!r?xe(a):0;var n=e.length;return a<0&&(a=fa(n+a,0)),Ke(e)?a<=n&&e.indexOf(t,a)>-1:!!n&&je(e,t,a)>-1}var _=na;var sa="[object Date]";function ia(e){return j(e)&&A(e)==sa}var Ge=ia;var qe=k&&k.isDate,pa=qe?K(qe):Ge,E=pa;var ua=S.isFinite;function la(e){return typeof e=="number"&&ua(e)}var V=la;var _e=ae(J(),1);var $f=(0,_e.default)();function g(e){if(e==null||typeof e!="object")return!1;let t=Object.getPrototypeOf(e);return t!==null&&t!==Object.prototype&&Object.getPrototypeOf(t)!==null?!1:!(Symbol.iterator in e)&&!(Symbol.toStringTag in e)}function C(e){return typeof e=="string"}function Je(e){return Number.isFinite(e)}function U(e){return typeof e=="boolean"}function P(e){return e!=null}function Qe(e,t){return g(e)&&C(t)&&t in e}function He(e,t){return e.localeCompare(t)}function v(e){return e==null?!1:Array.isArray(e)||typeof e=="string"?!!e.length:g(e)?!!Object.keys(e).length:typeof e=="number"}var Ye=ae(J(),1);function Q(e){if(typeof e!="string")throw new TypeError("Expected a string");return e.replace(/[|\\{}()[\]^$+*?.]/g,"\\$&").replace(/-/g,"\\x2d")}var H=new Map,Xe=(e,t)=>{if(!Array.isArray(e))switch(typeof e){case"string":e=[e];break;case"undefined":e=[];break;default:throw new TypeError(`Expected '${t}' to be a string or an array, but got a type of '${typeof e}'`)}return e.filter(a=>{if(typeof a!="string"){if(typeof a>"u")return!1;throw new TypeError(`Expected '${t}' to be an array of strings, but found a type of '${typeof a}' in the array`)}return!0})},ca=(e,t)=>{t=h({caseSensitive:!1},t);let a=e+JSON.stringify(t);if(H.has(a))return H.get(a);let r=e[0]==="!";r&&(e=e.slice(1)),e=Q(e).replace(/\\\*/g,"[\\s\\S]*");let n=new RegExp(`^${e}$`,t.caseSensitive?"":"i");return n.negated=r,H.set(a,n),n},ya=(e,t,a,r)=>{if(e=Xe(e,"inputs"),t=Xe(t,"patterns"),t.length===0)return[];t=t.map(o=>ca(o,a));let{allPatterns:n}=a||{},f=[];for(let o of e){let s,u=[...t].fill(!1);for(let[l,c]of t.entries())if(c.test(o)&&(u[l]=!0,s=!c.negated,!s))break;if(!(s===!1||s===void 0&&t.some(l=>!l.negated)||n&&u.some((l,c)=>!l&&!t[c].negated))&&(f.push(o),r))break}return f};function G(e,t,a){return ya(e,t,a,!0).length>0}var xa={arrayVsArrayAllMustBeFound:"any",caseSensitive:!0};function X(e,t,a){if(!e.length||!t.length)return!1;let r=h(h({},xa),a),n=typeof e=="string"?[e]:Array.from(e);return typeof t=="string"?n.some(f=>G(f,t,{caseSensitive:r.caseSensitive})):r.arrayVsArrayAllMustBeFound==="any"?t.some(f=>n.some(o=>G(o,f,{caseSensitive:r.caseSensitive}))):t.every(f=>n.some(o=>G(o,f,{caseSensitive:r.caseSensitive})))}var p=(0,Ye.default)();var O=Array.isArray;function Ze(e){return!!e&&e.some(t=>typeof t=="string")}function ba(e,t){return Object.keys(e).length===0||Object.keys(t).length===0||Object.keys(e).every(a=>Object.keys(t).includes(a))||Object.keys(t).every(a=>Object.keys(e).includes(a))}function b(e){return e===null?"null":E(e)?"date":g(e)?"object":O(e)?"array":typeof e}var ga={cb:null,mergeObjectsOnlyWhenKeysetMatches:!0,ignoreKeys:[],hardMergeKeys:[],hardArrayConcatKeys:[],mergeArraysContainingStringsToBeEmpty:!1,oneToManyArrayObjectMerge:!1,hardMergeEverything:!1,hardArrayConcat:!1,ignoreEverything:!1,concatInsteadOfMerging:!0,dedupeStringsInArrayValues:!1,mergeBoolsUsingOrNotAnd:!0,useNullAsExplicitFalse:!1};function w(e,t,a,r){var c;let n;if(r.useNullAsExplicitFalse&&(t===null||a===null))return typeof r.cb=="function"?r.cb(t,a,null,{path:e.path,key:e.key,type:e.type}):null;let f=O(t)||g(t)?p(t):t,o=O(a)||g(a)?p(a):a,s;r.ignoreEverything?s=f:r.hardMergeEverything&&(s=o);let u=r.hardMergeEverything||r.ignoreEverything;if(O(f))if(v(f))if(O(o)&&v(o)){if(r.mergeArraysContainingStringsToBeEmpty&&(Ze(f)||Ze(o))){let i=u?s:[];return typeof r.cb=="function"?r.cb(p(t),p(a),i,{path:n,key:e.key,type:e.type}):i}if(r.hardArrayConcat){let i=u?s:f.concat(o);return typeof r.cb=="function"?r.cb(p(t),p(a),i,{path:n,key:e.key,type:e.type}):i}let m=[];for(let i=0,x=Math.max(f.length,o.length);i<x;i++)n=(c=e.path)!=null&&c.length?`${e.path}.${i}`:`${i}`,g(f[i])&&g(o[i])&&(r.mergeObjectsOnlyWhenKeysetMatches&&ba(f[i],o[i])||!r.mergeObjectsOnlyWhenKeysetMatches)?m.push(w({path:n,key:e.key,type:[b(f),b(o)]},f[i],o[i],r)):r.oneToManyArrayObjectMerge&&(f.length===1||o.length===1)?m.push(f.length===1?w({path:n,key:e.key,type:[b(f),b(o)]},f[0],o[i],r):w({path:n,key:e.key,type:[b(f),b(o)]},f[i],o[0],r)):r.concatInsteadOfMerging?(i<f.length&&m.push(f[i]),i<o.length&&m.push(o[i])):(i<f.length&&m.push(f[i]),i<o.length&&!_(f,o[i])&&m.push(o[i]));r.dedupeStringsInArrayValues&&m.every(i=>C(i))&&(m=[...new Set(m)].sort(He)),f=p(m)}else{let m=u?s:f;return typeof r.cb=="function"?r.cb(p(t),p(a),m,{path:n,key:e.key,type:e.type}):m}else{if(v(o)){let i=u?s:o;return typeof r.cb=="function"?r.cb(p(t),p(a),i,{path:n,key:e.key,type:e.type}):i}let m=u?s:f;return typeof r.cb=="function"?r.cb(p(t),p(a),m,{path:n,key:e.key,type:e.type}):m}else if(g(f)){if(v(f)){if(O(o)){if(v(o)){let d=u?s:o;return typeof r.cb=="function"?r.cb(p(t),p(a),d,{path:n,key:e.key,type:e.type}):d}let x=u?s:f;return typeof r.cb=="function"?r.cb(p(t),p(a),x,{path:n,key:e.key,type:e.type}):x}if(g(o)){Object.keys(o).forEach(d=>{var Z;n=(Z=e.path)!=null&&Z.length?`${e.path}.${d}`:`${d}`,Qe(f,d)?X(d,r.ignoreKeys)?f[d]=w({path:n,key:d,type:[b(f),b(o)]},f[d],o[d],F(h({},r),{ignoreEverything:!0})):X(d,r.hardMergeKeys)?f[d]=w({path:n,key:d,type:[b(f),b(o)]},f[d],o[d],F(h({},r),{hardMergeEverything:!0})):X(d,r.hardArrayConcatKeys)?f[d]=w({path:n,key:d,type:[b(f),b(o)]},f[d],o[d],F(h({},r),{hardArrayConcat:!0})):f[d]=w({path:n,key:d,type:[b(f[d]),b(o[d])]},f[d],o[d],r):f[d]=o[d]});let x=u?s:f;return typeof r.cb=="function"?r.cb(p(t),p(a),x,{path:e.path,key:e.key,type:e.type}):f}let i=u?s:f;return typeof r.cb=="function"?r.cb(p(t),p(a),i,{path:e.path,key:e.key,type:e.type}):i}if(O(o)||g(o)||v(o)){let i=u?s:o;return typeof r.cb=="function"?r.cb(p(t),p(a),i,{path:e.path,key:e.key,type:e.type}):i}let m=u?s:f;return typeof r.cb=="function"?r.cb(p(t),p(a),m,{path:e.path,key:e.key,type:e.type}):m}else if(E(f)){if(V(+f)){if(E(o)){if(V(+o)){let d=u?s:f>o?f:o;return typeof r.cb=="function"?r.cb(p(t),p(a),d,{path:e.path,key:e.key,type:e.type}):d}let x=u?s:f;return typeof r.cb=="function"?r.cb(p(t),p(a),x,{path:e.path,key:e.key,type:e.type}):x}let i=u?s:o||f;return typeof r.cb=="function"?r.cb(p(t),p(a),i,{path:e.path,key:e.key,type:e.type}):i}if(E(o)){let i=u?s:o;return typeof r.cb=="function"?r.cb(p(t),p(a),i,{path:e.path,key:e.key,type:e.type}):i}let m=u?s:o;return typeof r.cb=="function"?r.cb(p(t),p(a),m,{path:e.path,key:e.key,type:e.type}):m}else if(C(f)){if(v(f)){if((O(o)||g(o)||C(o))&&v(o)){let x=u?s:o;return typeof r.cb=="function"?r.cb(p(t),p(a),x,{path:e.path,key:e.key,type:e.type}):x}let i=u?s:f;return typeof r.cb=="function"?r.cb(p(t),p(a),i,{path:e.path,key:e.key,type:e.type}):i}if(P(o)&&!U(o)){let i=u?s:o;return typeof r.cb=="function"?r.cb(p(t),p(a),i,{path:e.path,key:e.key,type:e.type}):i}let m=u?s:f;return typeof r.cb=="function"?r.cb(p(t),p(a),m,{path:e.path,key:e.key,type:e.type}):m}else if(Je(f)){if(v(o)){let i=u?s:o;return typeof r.cb=="function"?r.cb(p(t),p(a),i,{path:e.path,key:e.key,type:e.type}):i}let m=u?s:f;return typeof r.cb=="function"?r.cb(p(t),p(a),m,{path:e.path,key:e.key,type:e.type}):m}else if(U(f)){if(U(o)){if(r.mergeBoolsUsingOrNotAnd){let x=u?s:f||o;return typeof r.cb=="function"?r.cb(p(t),p(a),x,{path:e.path,key:e.key,type:e.type}):x}let i=u?s:f&&o;return typeof r.cb=="function"?r.cb(p(t),p(a),i,{path:e.path,key:e.key,type:e.type}):i}if(P(o)){let i=u?s:o;return typeof r.cb=="function"?r.cb(p(t),p(a),i,{path:e.path,key:e.key,type:e.type}):i}let m=u?s:f;return typeof r.cb=="function"?r.cb(p(t),p(a),m,{path:e.path,key:e.key,type:e.type}):m}else if(f===null){if(P(o)){let i=u?s:o;return typeof r.cb=="function"?r.cb(p(t),p(a),i,{path:e.path,key:e.key,type:e.type}):i}let m=u?s:f;return typeof r.cb=="function"?r.cb(p(t),p(a),m,{path:e.path,key:e.key,type:e.type}):m}else{let m=u?s:o;return typeof r.cb=="function"?r.cb(p(t),p(a),m,{path:e.path,key:e.key,type:e.type}):m}let l=u?s:f;return typeof r.cb=="function"?r.cb(p(t),p(a),l,{path:e.path,key:e.key,type:e.type}):l}function et(e,t,a){var n,f;if(!arguments.length)throw new TypeError("object-merge-advanced/mergeAdvanced(): [THROW_ID_01] Both inputs are missing");if(P(a)&&!g(a))throw new TypeError(`object-merge-advanced/mergeAdvanced(): [THROW_ID_02] The optional options object should be a plain object, currently it's ${JSON.stringify(a,null,4)} (type ${typeof a})`);let r=h(h({},ga),a);return typeof r.ignoreKeys=="string"&&(r.ignoreKeys=[r.ignoreKeys]),typeof r.hardMergeKeys=="string"&&(r.hardMergeKeys=[r.hardMergeKeys]),(n=r==null?void 0:r.hardMergeKeys)!=null&&n.includes("*")&&(r.hardMergeEverything=!0),(f=r==null?void 0:r.ignoreKeys)!=null&&f.includes("*")&&(r.ignoreEverything=!0),w({key:null,path:"",type:[b(e),b(t)]},e,t,r)}var tt="4.0.19";var Aa=tt,rt={dedupe:!0};function ja(e){return Object.keys(e).sort().reduce((t,a)=>(t[a]=e[a],t),{})}function va(e,t){if(Array.isArray(e)){if(e.length===0)return{}}else throw new Error(`array-of-arrays-into-ast: [THROW_ID_01] inputArr must be array. Currently it's of a type ${typeof e} equal to:
${JSON.stringify(e,null,4)}`);let a=h(h({},rt),t),r={};return e.forEach(n=>{let f=null;for(let o=n.length;o--;)f={[n[o]]:[f]};r=et(r,f,{concatInsteadOfMerging:!a.dedupe})}),ja(r)}return mt(Oa);})();
/**
 * @name codsen-utils
 * @fileoverview Various utility functions
 * @version 1.6.4
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/codsen-utils/}
 */
/**
 * @name util-nonempty
 * @fileoverview Is the input (plain object, array, string or whatever) not empty?
 * @version 5.0.15
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/util-nonempty/}
 */
/**
 * @name object-merge-advanced
 * @fileoverview Deeply merge JSON-like data structures
 * @version 14.0.18
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/object-merge-advanced/}
 */
/*! Bundled license information:

lodash-es/lodash.js:
  (**
   * @license
   * Lodash (Custom Build) <https://lodash.com/>
   * Build: `lodash modularize exports="es" -o ./`
   * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
   * Released under MIT license <https://lodash.com/license>
   * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
   * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
   *)
*/
